package com.waitrose.jsftest.validators;

import org.apache.commons.validator.EmailValidator;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import java.util.ResourceBundle;
import java.text.MessageFormat;

/**
 * Created by IntelliJ IDEA.
 * User: roffiah
 * Date: 15-Jun-2006
 * Time: 09:20:59
 */

/**
 * This class is used to ensure that any email message entered is valid
 */
public class EmailAddressValidator implements Validator {
    public void validate(FacesContext facesContext, UIComponent uiComponent, Object object) throws ValidatorException {

        if (object == null) {
            return;
        }

        String email = (String) object;

        System.out.println("Email validator running!");

        // ok, so how do we know the email addres  is valid

        EmailValidator emailValidator = EmailValidator.getInstance();

        if (!emailValidator.isValid(email)) {

            ResourceBundle resourceBundle =
                    ResourceBundle.getBundle("com.waitrose.jsftest.messages.messages", facesContext.getViewRoot().getLocale());

            String str_message = resourceBundle.getString("com.waitrose.jsftest.messages.invalid_email_address");
            Object[] arguments = {email};
            ((UIInput) uiComponent).setValid(false);
            FacesMessage message = new FacesMessage();
            message.setDetail(MessageFormat.format(str_message, arguments));
            message.setSummary("Invalid email address");
            message.setSeverity(FacesMessage.SEVERITY_ERROR);
            throw new ValidatorException(message);

        }


    }
}
